# -*- coding: utf-8 -*-
import platform,os
import logging,json
import sys
import datetime
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)
from __init__ import checkInfo,suggest_osdict,configdict

# poc 根盘10G,大于9G，production 100G,大于98G
# poc 数据盘300G,大于290G，production 500G,大于495

cfinfo1 = {"six-less":{"use": 0.8, "root_size": 1048576*9,"data_size":1048576*290, 'RootPath': '/',"root_normal":10,"data_normal":300},
          "six-more":{"use": 0.8, "root_size": 1048576*95, "data_size":1048576*495,'RootPath': '/',"root_normal":100,"data_normal":500}
          }

# 磁盘空间与inode数量比值
# inode_check = 20
# inode_useage_rate = 80

def get_args():
    env,data_dir,app = sys.argv[2],sys.argv[3],sys.argv[8]
    return env,data_dir,app

class CheckDisk():
    def get_host_ip(self):
        return sys.argv[1]

    #cfinfo = {"use": 0.8, "size": 19922944, 'RootPath': '/'}
    
    def check_xfs_info(self, info):
        ftype = -1
        for line in info:
            line_items = line.strip().rstrip().split()
            for item in line_items:
                item = item.strip().rstrip()
                if item.startswith('ftype='):
                    if item == 'ftype=1':
                        ftype = 1
                    elif item == 'ftype=0':
                        ftype = 0
        return ftype


    def checkfs(self,fstype):
        checkStatus=''
        ip_address=self.get_host_ip()
        env,data_dir,app = get_args()
        if os.path.isdir(data_dir) == False:
            checkStatus=checkStatus + "挂载目录不存在" +data_dir
            return False,checkStatus
        result=os.popen("df -Th "+data_dir+" | grep /dev/ | grep -v tmpfs  |awk '{print $2}'").read().replace("\n",'')
        if result:
            if result==fstype:
                if result=="xfs":
                   result_xfs_info = os.popen("sudo /usr/sbin/xfs_info {0} |grep ftype".format(data_dir)).read()
                   result_xfs_info = result_xfs_info.strip().rstrip().split('\n')
                   ftype = self.check_xfs_info(result_xfs_info)
                   if ftype!=1:
                      checkStatus="数据盘挂载不正常，请将数据盘{0}的ftype值设置为1".format(data_dir)
                      return False,checkStatus
            elif result=="nfs" or result=="NFS":
                checkStatus="数据盘挂载不正常，不能使用nas挂载数据盘"  
                return False,checkStatus
            else:
                checkStatus='数据盘挂载硬盘格式错误，请给{0}目录挂载{1}格式的硬盘'.format(data_dir,fstype)
                return False,checkStatus
            return True,checkStatus
        else:
            return False,'获取挂载信息异常'

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def checkDisk(self,ip):
        env,data_dir,app = get_args()
        cf = configdict.get(app,{}).get("disk",{})
        inode_check = cf.get("inode_check",20)
        inode_useage_rate = cf.get("inode_useage_rate",80)
        if not cf:
            return '获取配置失败',0,'请检查环境检查配置文件是否有误'
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        checkStatus = {"use":[],"size":[],"fstab":[],"inode":[],"warn_size":[]}
        #挂载是否正常
        # 数据盘挂载格式
        fstab_data_disk_type = os.popen("grep -v '#' /etc/fstab |grep %s| awk '{print $2,$3}' | grep -v swap | grep -v auto | awk '{print $2}'"%(data_dir)).read().strip('\n')
        osDict = {"ext4":["Ubuntu","Kylin"],
                  "xfs":["Red Hat","CentOS","Kylin-V10","neokylin","Kylin"],
                  "btrfs":["SUSE"]
                  }
        for dtype,otypes in osDict.items():
            if ostype in otypes:
                #print (fstab_data_disk_type,dtype)
                if fstab_data_disk_type:
                    if fstab_data_disk_type != dtype:
                        checkStatus['fstab'].append("当前fstab挂载数据盘{}为{},与实际挂载格式{}格式不一致,请修改fstab配置重新挂载".format(data_dir,fstab_data_disk_type,dtype))
                
                st,msg = self.checkfs(dtype)
                if not st:
                    checkStatus['fstab'].append(msg)
        path_list=os.popen("df -h | grep /dev/ | grep -v tmpfs | awk '{print $6}'").read().strip().split("\n")
        fstab_path_list=os.popen("grep -v '#' /etc/fstab | awk '{print $2,$3}' | grep -v swap | grep -v auto | awk '{print $1}'").read().split()
        for path in path_list+[data_dir]:
            if path not in fstab_path_list:
                checkStatus['fstab'].append("数据盘挂载不正常 fstab中未配置挂载目录:{}".format(path))
                break
        
        #磁盘使用率
        #disk_str = []
        disk_used = os.popen("df -h | grep /dev/ | grep -v tmpfs | awk '{print $1,$2,$5,$NF}' | sort -n | uniq").read().strip().split("\n")
        for used in disk_used:
            if len(used.split(" ")) != 4:
                continue
            _used=float(used.split(" ")[2].split("%")[0])/100
            disk_path = used.split(" ")[-1]
            if _used>cf.get(env).get("use",0.8):
                checkStatus['use'].append("磁盘{}使用率超过80%.".format(disk_path))
        
        # 系统盘分区大小
        systemData=os.popen("df | grep /dev/ | grep -v tmpfs  | grep -E '/$' | awk '{print $2}'").read()
        try:
            size=int(systemData.strip('\n'))
        except:
            size = 0
        if size < cf.get(env).get("root_size",90)*1048576:
            if size > cf.get(env).get("warn_root_size",9)*1048576:
                checkStatus['warn_size'].append("系统根磁盘容量低于最优值{}G,请扩容".format(cf.get(env).get("root_normal")))
            else:
            #print_size = os.popen("df -h / |grep /dev | awk '{print $2}'").read().strip()
                checkStatus['size'].append("系统根磁盘容量低于最小值{}G,请扩容".format(cf.get(env).get("warn_root_normal")))

        # 数据盘分区大小
        if not os.path.isdir(data_dir):
            checkStatus['use'].append('{}路径挂载目录不存在'.format(data_dir))
        else:
            DataDisk=os.popen("df  "+data_dir+" |grep /dev | awk '{print $2}'").read()
            try:
                size = int(DataDisk.strip('\n'))
            except:
                size = 0
            if size < cf.get(env).get("data_size",490)*1048576:
                if size > cf.get(env).get("warn_data_size",290)*1048576:
                    checkStatus['warn_size'].append("数据盘{}容量低于最优值{}G,请扩容".format(data_dir,cf.get(env).get("data_normal")))
                else:
                #print_size=os.popen("df -h "+data_dir+" |grep /dev | awk '{print $2}'").read().strip()
                    checkStatus['size'].append("数据盘{}容量低于最小值{}G,请扩容".format(data_dir,cf.get(env).get("warn_data_normal")))

            # 数据盘inodesize
            inode_number = os.popen("df -i "+data_dir+" | grep /dev/ | grep -v tmpfs  |awk '{print $2}'").read().replace("\n",'')
            disk_size = os.popen("df -k "+data_dir+" | grep /dev/ | grep -v tmpfs  |awk '{print $2}'").read().replace("\n",'')
            try:
                inode_size = int(round(float(disk_size) / float(inode_number)))
                if inode_size > inode_check*1000:
                    checkStatus['inode'].append("数据盘{}的Inode 数量太少,当前磁盘空间与inode数量比值为 {}请调整到小于{}k".format(data_dir,inode_size,inode_check))
            except:
                pass
    
            # 数据盘inode使用量,suse获取为-,不做判断
            inode_useage = os.popen("df -i "+data_dir+" | grep /dev/ | grep -v tmpfs  |awk '{print $5}'").read().replace("\n",'')
            if inode_useage != '-':
                if int(inode_useage.replace('%','')) > inode_useage_rate:
                    checkStatus['inode'].append("数据盘{}的Inode已使用 {},请调整到小于{}%".format(data_dir,inode_useage,inode_useage_rate))

        

        status = True
        for k,v in checkStatus.items():
            if v:
                status = False
        if status:
            info="硬盘检查正常。"
            #logging.info("硬盘检查正常。")
            return info,1,""
        else:
            info = ''
            suggest = ''
            if checkStatus.get("fstab"):
                info +='\n'.join(checkStatus.get('fstab'))+'\n'
                suggest += '数据盘必须作为独立磁盘挂载,并且挂载格式需与要求一致\n'
                return info.strip('\n'),0,suggest.strip('\n')
            if checkStatus.get('use'):
                info = '\n'.join(checkStatus.get('use'))+'\n'
                suggest = '请检查磁盘路径及使用率\n'
            if checkStatus.get("size"):
                info +='\n'.join(checkStatus.get('size'))+'\n'
                suggest += '请按提示扩容磁盘\n'
            if checkStatus.get("inode"):
                info +='\n'.join(checkStatus.get('inode'))+'\n'
                suggest += '请调整inode数量\n'
            if info and suggest:
                return info.strip('\n'),0,suggest.strip('\n')
            else:
                if checkStatus.get("warn_size"):
                    info +='\n'.join(checkStatus.get('warn_size'))+'\n'
                    suggest += '建议按提示扩容磁盘\n'
                    return info.strip('\n'),1,suggest.strip('\n')
            return info.strip('\n'),0,suggest.strip('\n')



    def main(self,ip):
        return self.checkDisk(ip)

if __name__ == '__main__':
    
    checkDisk = CheckDisk()
    ip_address=checkDisk.get_host_ip()
    info,status,suggest = checkDisk.main(ip_address)
    print(json.dumps({'info': info,'name':'检测硬盘空间及挂载','status': status,'suggest':suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))