# -*- coding: utf-8 -*-
import platform,os
import logging,json
import sys
import string
import datetime
import subprocess

defaultencoding = 'utf-8'
from __init__ import checkInfo,configdict

#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)
envDict1 = {
    "six-more":20,
    "six-less":5
}
def get_args():
    env,data_dir,app = sys.argv[2],sys.argv[3],sys.argv[8]
    return env,data_dir,app

def exec_cmd(cmd, workdir = None):
    import subprocess, platform,string
    """
    @return: (int, str) (退出码, 输出字符串)
    """
    #logging.info(u"执行命令: [%s]" % cmd)

    #cmd = shlex.split(cmd)
    proc = subprocess.Popen(cmd, shell=True, stdout = subprocess.PIPE, stderr = subprocess.STDOUT, cwd = workdir)
    stdout = []
    while proc.poll() is None:
        if proc.stdout:
            stdoutline = proc.stdout.readline().strip()

            if stdoutline:
                stdout.append(stdoutline)
                #logging.debug(stdoutline)
    return proc.returncode, str(stdout[-1])

class CheckDiskIO():

    # 检查磁盘io性能
    def cal_disk_io(self):
        env,data_dir,app = get_args()
        cmd = "sudo timeout 60 dd if=/dev/zero of={}/a.dat bs=8k count=20K oflag=direct".format(data_dir)
        totals = []
        for i in range(3):
            try:
                code,msg = exec_cmd(cmd)
                if not code:
                    if '秒' in msg:
                        tmp = msg.split("，")[-1].strip(' ').replace("'","")
                        if 'kb' in tmp.lower():
                            dd = float(tmp.split(' ')[0])/1024
                        else:
                            dd = float(tmp.split(' ')[0])
                        totals.append(dd)
                    else:
                        if "，" in msg:
                            _val = msg.split("，")[-1].strip(' ').replace("'","").split(' ')[0]
                        else:
                            _val = msg.split(",")[-1].strip(' ').replace("'","").split(' ')[0]
                        totals.append(_val)
                else:
                    totals.append(0)
            except Exception as err:
                #logging.error(str(err))
                totals.append(0)
        
        if env not in ["six-less","six-more"]:
            env = 'six-more'
        a = round(sum([float(f) for f in totals])/len(totals),2)
        envDict = configdict.get(app,{}).get("diskio",{})
        io_value = envDict.get(env,20)
        if a > io_value:
            info="数据盘{}硬盘IO检查正常,当前磁盘io测试值为{}MB/s!".format(data_dir,a)
            return info,1,""
        else:
            if a > envDict.get("warn_{}".format(env),10):
                info="数据盘{}当前磁盘io测试值为{}MB/s,低于最优阈值{}MB/s!".format(data_dir,a,io_value)
                return info,1,'数据盘读写性能需优化提高,以免影响业务使用'
            else:
                info="数据盘{}硬盘IO检查不正常,当前磁盘io测试值为{}MB/s,低于阈值{}MB/s!".format(data_dir,a,io_value)
                return info,0,"数据盘{}磁盘io性能低于{}MB/s，请更换磁盘\n 检测命令：dd if=/dev/zero of={}/a.dat bs=8k count=20K oflag=direct".format(data_dir,io_value,data_dir)


    def main(self):
        return self.cal_disk_io()

if __name__ == '__main__':
    checkDiskio = CheckDiskIO()
    info,status,suggest = checkDiskio.main()
    print(json.dumps({'info': info,'name':'检测硬盘IO','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))