# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys

defaultencoding = 'utf-8'
import socket
import threading
import time
import datetime
import struct
import re
py3k = sys.version_info[0] >= 3


def match_ip(string_ip,res=False):
    iplist = []
    iplist = re.findall(r"(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)", string_ip)
    if res:
        return iplist
    if iplist:
        return True
    else:
        return False
def get_local_ip():
    ip = os.popen("ip route get 1 | awk -F 'uid' '{print $1}' | awk '{print $NF;exit}'")
    ip = ip.read().replace("\n", '')
    return ip
class CheckDns():
    def checkDns(self):
        
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        if not os.path.exists('/etc/resolv.conf'):
            info = '/etc/resolv.conf 文件不存在'
            return info,0,'请添加resolv.conf配置文件'
        if ostype in ["Kylin","Kylin-V10"]:
            if os.path.islink('/etc/resolv.conf'):
                info = '/etc/resolv.conf不能为软链接'
                return info,0,'请将/etc/resolv.conf软连接处理为文件'
        output = os.popen("cat /etc/resolv.conf|grep nameserver|grep -v '#nameserver'").read()
        iplist = [h.strip() for h in output.split('\n') if h]
        if not iplist:
            info = 'nameserver 没有配置解析'
            return info,0,"请配置nameserver 域名解析"
        
        status = True
        msgs = []
        compile_ip=re.compile(
            '^(1\d{2}|2[0-4]\d|25[0-5]|[1-9]\d|[1-9])\.(1\d{2}|2[0-4]\d|25[0-5]|[1-9]\d|\d)\.(1\d{2}|2[0-4]\d|25[0-5]|[1-9]\d|\d)\.(1\d{2}|2[0-4]\d|25[0-5]|[1-9]\d|\d)$')
        checks = []
        for ip in iplist:
            if ip.startswith("#"):
                checks.append(ip)
                continue
            #if '127.0.0.1' in ip:
            #    info = 'nameserver不能配置127.0.0.1'
            #    return info,0,'请去掉nameserver 127.0.0.1解析配置'
            if not match_ip(ip):
                return '{}配置不正确'.format(ip),0,'nameserver必须配置为ip'
            
        if len(checks) == len(iplist):
            return '没有配置域名解析',0,'请配置域名解析,格式为nameserver xx.xx.xx.xx'
        ping_res = os.popen('ping -w 1 -c 1 ab.bs.cf.com').read() 
        if match_ip(ping_res):
            return 'dns配置不正确',0,'请去掉/etc/resolv.conf中的search配置'
        hostname = os.popen('hostname').read().strip('\n')
        host_result = []
        for hh in ["localhost"]:
            hostname_ping = os.popen('ping -w 1 -c 1 {}'.format(hh)).read()
            hostname_ping_res = match_ip(hostname_ping,True)
            local_ip = get_local_ip()
            if hostname_ping_res:
                if '127.0.0.1' in hostname_ping_res or local_ip  in hostname_ping_res:
                    pass
                else:
                    host_result.append('建议增加 {} 的ip解析,解析127.0.0.1或者{}'.format(hh,local_ip))
            else:
                host_result.append('建议增加 {} 的ip解析,解析127.0.0.1或者{}'.format(hh,local_ip))
        if host_result:
            return 'dns检查异常',0,'\n'.join(host_result)

        if status:
            info = "dns检查正常"
            #logging.info(" 端口没有被占用。")
            return info,1,""
        else:
            info="dns服务器{} 53端口不通".format(','.join(msgs))
            #logging.warning(info)
            return info,0,"请检查dns服务器是否正常设置"

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"
    def main(self):
        return self.checkDns()

if __name__ == '__main__':
    checkDns = CheckDns()
    info,status,suggest = checkDns.main()
    print(json.dumps({'info': info,'name':'检测DNS','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


