# -*- coding: utf-8 -*-
import os,platform
import re,json
from multiprocessing import cpu_count
import logging
import sys
import datetime
defaultencoding = 'utf-8'
from __init__ import checkInfo,configdict

#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)
def get_platform():
    stdout = os.popen('uname -m').read()
    return stdout.strip('\n')
def get_args():
    env,app = sys.argv[2],sys.argv[8]
    return env,app

#print (cfinfo)
cfinfo1 ={
    "x86_64":{
         'six-more':{"cpu":8,"memery":1048576*30,"normal":'8c32g'},
         'six-less':{"cpu":8,"memery":1048576*60,"normal":'8c64g'}
        },
    "aarch64":{
         'six-more':{"cpu":16,"memery":1048576*30,"normal":'16c32g'},
         'six-less':{"cpu":16,"memery":1048576*60,"normal":'16c64g'}
        },
    "mips64el":{
         'six-more':{"cpu":16,"memery":1048576*30,"normal":'16c32g'},
         'six-less':{"cpu":16,"memery":1048576*60,"normal":'16c64g'}
        }
    }
class CheckHardware():
    
    @property
    def checkHardware(self):
        env,app = get_args()
        if not env or env not in ['six-less','six-more']:
            env = 'six-more'
        _platform = get_platform()
        cfinfo = configdict.get(app,{}).get("memory",{})
        cf = cfinfo.get(_platform,{}).get(env)
        #print (cf)
        if not cf:
            #logging.error("获取平台信息错误")
            return "获取平台信息错误",0,"请检查机器平台是否为x86_64/aarch64/mips64el"
        cpu = cf["cpu"]
        memery = cf["memery"]
        warninfo=''
        #cpu
        cpuCount= cpu_count()
        output1 = os.popen("cat /proc/meminfo")
        output1 = output1.read()
        matched = re.search(r'^MemTotal:\s+(\d+)', output1)
        meminfo = 0
        if matched != None:
            meminfo = int(matched.groups()[0])

        if int(cpuCount) < int(cpu):
            warninfo = "部署环境CPU核数不满足需求,当前为"+str(cpuCount)+"C"
            #logging.warning(" 部署环境CPU不满足需求 [X]")
            #return False
        #内存
        meminfo_g=format(float(meminfo)/float(1048576),'.2f')
        if float(meminfo_g) < memery:
            warninfo=warninfo +"\n"+"部署环境内存大小不满足需求,当前为"+str(meminfo_g)+"G"
            #logging.warning(" 部署环境内存满足不需求 [X]")
            #return False
        if warninfo =='':
            info = "部署环境CPU和内存满足需求,当前为"+str(cpuCount)+"C/"+str(meminfo_g)+"G。"
            #logging.info(" 部署环境CPU和内存满足需求!")
            return info,1,""
        else:
            info = warninfo
            #logging.warning(" 部署环境:"+warninfo+ " !")
            return info,0,"内存或CPU不满足要求,{}平台{}环境要求配置{},请扩容机器".format(_platform,env,cf.get("normal"))

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        return self.checkHardware


if __name__ == '__main__':
    
    checkHardware = CheckHardware()
    info,status,suggest= checkHardware.main()
    print(json.dumps({'info': info, 'name':'检测CPU和内存','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))
