# -*- coding: utf-8 -*-
import os
import re
import json
import sys
import datetime

class CheckHostip():
    
    def get_kubeconf_ip_list(self):
        return sys.argv[6]

    def get_local_ip(self):
        ip = os.popen("ip route get 1 | awk -F 'uid' '{print $1}' | awk '{print $NF;exit}'")
        ip = ip.read().replace("\n", '')
        return ip

    def check_dhcp_ip(self, ip):
        cmd = "ip addr | grep {}| awk '{{print $NF}}'".format(ip)
        net_name = os.popen(cmd).read().strip()
        cmd = "ls -l /var/run/ |grep dhclient|awk '{print $NF}'"
        dh_pid_files = os.popen(cmd).read().split()

        if not dh_pid_files:
            return False
        else:
            for files in dh_pid_files:
                if re.search(net_name, files):
                    return True
            return False

    def checkHostip(self):
        local_ip=self.get_local_ip()
        #print local_ip,host_ip
        kubeconf_ip_list=self.get_kubeconf_ip_list().split(',')
        if self.check_dhcp_ip(local_ip):
            return "{}是dhcp获取ip，请配置为static".format(local_ip),1,'建议将主机ip设置为静态ip,以防机器重启ip变更导致集群故障。如果是aws，aliyun之类的cloud-init的metada环境的dhcp则忽略'
        if '127.0.0.1' in kubeconf_ip_list:
            return "检查正常", 1,""
        if local_ip in kubeconf_ip_list:
            info = "host ip: "+local_ip+" 是内网ip，检查正常。"
            return info, 1,""
        else:
            info = "本机默认IP是{},不在部署主机列表内，请删除host重新填写内网ip地址!".format(local_ip)
            return info, 0,"执行ip route get 1 | awk -F 'uid' '{print $1}' | awk '{print $NF;exit}' 查看内网ip是否正确"

    def main(self):
        return self.checkHostip()


if __name__ == '__main__':
    checkhostip = CheckHostip()
    info, status,suggest = checkhostip.main()
    print(json.dumps({'info': info, 'name': '检查Host ip', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))
