# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
from __init__ import checkInfo,configdict

defaultencoding = 'utf-8'
if sys.getdefaultencoding() != defaultencoding:
    reload(sys)
    sys.setdefaultencoding(defaultencoding)

def get_args():
    env,app = sys.argv[2], sys.argv[8]
    return env,app
cfinfo1 ={'maxKernel':'4.20.0','minKernel':'3.10.0'}

def compare_version(s_version,l_version):
    #判断版本号大小,ture为 s_version小于l_version
    s_slice = s_version.split('.')
    l_slice = l_version.split('.')
    for i in range(len(s_slice)):
        if int(s_slice[i]) > int(l_slice[i]):
            return False
    return True


class CheckKernel():
    def checkType(self):
        env,app = get_args()
        cfinfo = configdict.get(app,{}).get("kernel",{})
        cf = cfinfo
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            return info,0,"不支持windows检测"
        elif ostype in ['Ubuntu','CentOS','Red Hat','SUSE','Kylin','Kylin-V10'] :
            output = os.popen('uname -r').read().strip('\n')
            #output = '4.5.1-311-generic (buildd@lgw01-amd64-015)'
            #output = '3.10.0-127.19.1.el7.x86_64'
            output3 = output.split('-')[0]
            minKernel = cf["minKernel"]
            maxKernel = cf["maxKernel"]
            if compare_version(output3,minKernel):
                if output3 == minKernel:
                    _tmp = output.split("-")[1]
                    if '-' in _tmp:
                        min_version = _tmp.split('-')[0]
                    else:
                        min_version = _tmp.split('.')[0]
                    if int(min_version) < 514:
                        info="linux version :  " + output + "不支持!"
                        return info, 0,"内核最低版本为3.10.0-514"
                    else:
                        info="linux version :  " + output + "支持 [√]"
                        return info, 1,""
                else:
                    info="linux version :  " + output + "不支持!"
                    return info, 0,"内核版本不能低于3.10.0"
            elif compare_version(maxKernel,output3):
                if maxKernel == output3:
                    info="linux version :  " + output + "支持 [√]"
                    return info, 1,""
                else:
                    info = " linux version :  "+output+"不支持。"
                    return info, 0,"内核版本不能高于4.20.0"
            else:
                info=" linux version :  "+output+"支持。"
                return info, 1,""
        else:
            info=" linux version  :  other不支持!"
            return info, 0,"系统不支持"


    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        """
        :type messageTable: object
        """
        return self.checkType()


if __name__ == '__main__':
    checkKernel = CheckKernel()
    info,status,suggest = checkKernel.main()
    print(json.dumps({'info': info,'name':'检测内核版本', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))

