# -*- coding: utf-8 -*-
import os
import json
import sys
import subprocess
import re
import datetime
from __init__ import checkInfo,configdict


def get_args():
    env,app = sys.argv[2],sys.argv[8]
    if env not in ['six-less','six-more']:
        env = 'six-more'
    return env, app
envDict = {
    "six-more":5,
    "six-less":10
}


class CheckNetworkDelay():
    

    def get_kubeconf_ip_list(self):
        return sys.argv[6].split(',')

    def get_local_ip(self):
        ip = os.popen("ip route get 1 | awk -F 'uid' '{print $1}' | awk '{print $NF;exit}'")
        ip = ip.read().replace("\n", '')
        return ip

    def delay_check(self):
        env, app = get_args()
        iplist = self.get_kubeconf_ip_list()
        local_ip = self.get_local_ip()
        result = {"fail":[],"high_delay":[],'lost':[]}
        envDict = configdict.get(app,{}).get("delay",{})
        delay_value = envDict.get(env,10)
        for domain in iplist:
            if not domain or local_ip == domain:
                continue
            ping_result = {'result': 'ok'}
            p = subprocess.Popen(
                "ping -c 4 {0} -i 0.5 \n".format(domain),
                stdin=subprocess.PIPE,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
                shell=True)
            out = p.stdout.read().decode('gbk')
            regIP = r'\d+\.\d+\.\d+\.\d+'
            regLost = r', (\d.*?%) packet loss'
            regAverage = r'= (.*?) ms'
            ip = re.search(regIP, out)
            try:
                lost = re.findall(regLost, out)[0]
                reaverage = re.findall(regAverage, out)
                if reaverage:
                    average = reaverage[0].split('/')[1]
                    ping_result['average'] = float(average)
                if ip:
                    ip = ip.group()
                    ping_result['ip'] = ip
                if lost:
                    lost = lost.split(',')[1].lstrip()
                    lost = float(lost.replace('%', ''))
                    ping_result['lost'] = lost
                if ping_result['lost'] >= 10:
                    ping_result['result'] = '全部丢包'
                if 'average' in ping_result:
                    if ping_result['average'] >= 300:
                        ping_result['result'] = "延时过高{ping_result['average']}"
            except:
                {'ip': domain, 'average': 0, 'result': 'fail', 'lost': 0}
            if ping_result.get('result') == 'ok':
                if float(ping_result.get("average")) > delay_value:
                    result['high_delay'].append('{}-->{}'.format(local_ip,domain))
                if float(ping_result.get('lost',0)) > 0:
                    result['lost'].append('{}-->{}'.format(local_ip,domain))
                
            else:
                result['fail'].append('{}-->{}'.format(local_ip,domain))
        fail_result,delay_result,lost_result = '','',''
        
        if result.get('fail',[]):
            fail_result = '; '.join(result.get('fail'))
        if result.get('high_delay',[]):
            delay_result = '; '.join(result.get("high_delay"))
        if result.get('lost',[]):
            lost_result = '; '.join(result.get("lost"))
        if fail_result and delay_result and lost_result:
            return '{}主机网络连接失败; {}主机网络延迟超过{}ms;{}网络有丢包'.format(fail_result,delay_result,delay_value,lost_result),0,'请检查提示主机网络连接'
        
        if fail_result:
            return '{}主机网络连接失败;'.format(fail_result),0,'请检查提示主机网络连接'
        if delay_result:
            return '{}主机网络延迟超过{}ms'.format(delay_result,delay_value),0,'请检查相关主机网络连接'
        if lost_result:
            return '{}网络有丢包'.format(lost_result),0,'请检查提示主机网络连接'

        return '主机网络延迟正常',1,''

                     
    def main(self):
        return self.delay_check()


if __name__ == '__main__':
    checknetwork = CheckNetworkDelay()
    info, status,suggest = checknetwork.main()
    print(json.dumps({'info': info, 'name': '检查主机网络延迟', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))
