# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
defaultencoding = 'utf-8'
from __init__ import checkInfo,configdict


def get_args():
    env,app = sys.argv[2],sys.argv[8]
    return env,app
##if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)

cfinfo ={"redis":["8531","8532","8533","8534","8535","8536"],
         "mysql":["3306","13306"],
         "app":["80","443"],
         "k8s":["6443","8443"],
         "kubewps":["8081","4306"]
         }

class CheckPort():
    def get_install_code(self):
        check = []
        codes = list(sys.argv[7])
        k8s,mysql,redis,app,kubewps = codes
        if k8s == '0':
            check.append('k8s')
        if redis == "0":
            check.append("redis")
        if mysql == '0':
            check.append("mysql")
        if app == '0':
            check.append("app")
        if kubewps == '0':
            check.append("kubewps")
        return check
    def checkPort(self):
        env,app = get_args()
        cf = configdict.get(app,{}).get("port",{})
        _install_check = self.get_install_code()
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        check_cmd_res = os.popen('sudo command -v netstat').read()
        cmd = 'sudo netstat -tunl'
        if 'netstat' not in check_cmd_res:
            cmd = "sudo ss -tunl"
        warningSysctl = []
        for item in _install_check:
            for port in cf.get(item,[]):
                if '-' in port:
                    _tmp = port.split('-')
                    if len(_tmp) != 2:
                        return '配置文件端口配置格式不正确',0,'配置文件端口配置格式不正确'
                    for p in range(int(_tmp[0]),int(_tmp[1])+1):
                        output1=os.popen("{}| grep ':{} '".format(cmd,p))
                        output1=output1.read().strip()
                        if output1 != '':
                            warningSysctl.append(str(p))
                else:
                    output1=os.popen("{}| grep ':{} '".format(cmd,port))
                    output1=output1.read().strip()
                    if output1 != '':
                        warningSysctl.append(port)

                
        if not warningSysctl:
            info = "部署所需端口没有被占用。"
            #logging.info(" 端口没有被占用。")
            return info,1,""
        else:
            info=" 端口: " + ','.join(set(warningSysctl)) + " 被占用 "
            #logging.warning(info)
            return "部署所需端口被占用",0,"{},请确认端口使用情况,使用{}查看".format(info,cmd)

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"
    def main(self):
        return self.checkPort()

if __name__ == '__main__':
    checkPort = CheckPort()
    info,status,suggest = checkPort.main()
    print(json.dumps({'info': info,'name':'检测系统端口占用','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


