# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
defaultencoding = 'utf-8'

softwares=['qaxsafed','secdog','YDservice',
           'Symantec','sangfor_watchdog',
           'wsssr_defence_service','wsssr_defence_daemon',
           'start360su_safed','gov_defence_service','gov_defence_guard']

class CheckSecuritySoftware():
    def checkSoftware(self):
        
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        
        warningSysctl = []
        for sysctlItem in softwares:
            output1=os.popen("ps -ef|grep '{}'|grep -v 'grep'".format(sysctlItem))
            output1=output1.read().strip()
            if output1 != '':
                warningSysctl.append(sysctlItem)
        if not warningSysctl:
            info = "没有检测到安全软件进程"
            #logging.info(" 端口没有被占用。")
            return info,1,""
        else:
            info="检测到有{}安全软件进程".format(','.join(warningSysctl))
            #logging.warning(info)
            return info,0,"本机安装有安防软件,请先卸载后再进行部署"

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"
    def main(self):
        return self.checkSoftware()

if __name__ == '__main__':
    checkSoft = CheckSecuritySoftware()
    info,status,suggest = checkSoft.main()
    print(json.dumps({'info': info,'name':'检测安全软件进程','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


