# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
import subprocess
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)

# 检测docker是否在运行
docker_flag=os.popen("systemctl list-units --type=service|grep docker").read()
if docker_flag:
    cfinfo = {"net.ipv4.ip_forward": 1,
              "net.bridge.bridge-nf-call-iptables": 1,
              "net.bridge.bridge-nf-call-ip6tables": 1,
              "net.bridge.bridge-nf-call-arptables": 1
              }
else:
    cfinfo = {"net.ipv4.ip_forward": 1,
              "net.bridge.bridge-nf-call-iptables": 1,
              "net.bridge.bridge-nf-call-ip6tables": 1,
              "net.bridge.bridge-nf-call-arptables": 1
              }

class CheckSysctl():
    def checkSysctl(self):
        cf = cfinfo
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
            
        sysctlItems=cfinfo.keys()
        warningSysctl = []
        proc = subprocess.Popen("sudo sysctl -n net.ipv4.ip_forward", shell=True, stdout = subprocess.PIPE, stderr = subprocess.STDOUT)
        stdout = []
        while proc.poll() is None:
            if proc.stdout:
                stdoutline = proc.stdout.readline().strip()
        output1 = proc.returncode
        if not output1:
            for sysctlItem in sysctlItems:
                output1=os.popen("sudo sysctl -n %s" % sysctlItem)
                output1=output1.read().strip('\n')
                try:
                    value = int(output1)
                except:
                    msg = "%s 配置不存在!" % sysctlItem
                    #warningSysctl.append(msg)
                else:
                    # 判断相关参数值是否正确
                    if cfinfo.get(sysctlItem) != value:
                        msg = '{}={} 配置不符合要求,应修改为{}!'.format(sysctlItem,value,cfinfo.get(sysctlItem))
                        warningSysctl.append(msg)
            if not warningSysctl:
                info="sysctl 内核参数正常。"
                #logging.info("sysctl 内核参数正常。")
                return info, 1,""
            else:
                info=" sysctl 内核参数不符合要求 : \n" + '\n'.join(warningSysctl) 
                #logging.warning(" sysctl 内核参数 : " + '\n'.join(warningSysctl) + " 不支持!")
                return info, 0,"请修改内核参数配置文件/etc/sysctl.conf"
        else:
            info="sysctl  命令执行异常,请检查!"
            #logging.warning("sysctl -p 报error!")
            return info, 0,"请检查sudo sysctl -a 是否正常"

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        return self.checkSysctl()

if __name__ == '__main__':
    checkSysctl = CheckSysctl()
    info,status,suggest = checkSysctl.main()
    print(json.dumps({'info': info,'name':'检测sysctl状态', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


