# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
defaultencoding = 'utf-8'


class CheckSystem():
    def checkSystem(self):
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        if ostype  == 'SUSE':
            out_suse = os.popen("cat /etc/systemd/system.conf|grep -v '#'|grep 'DefaultTasksMax' ").read().strip('\n')
            if out_suse.startswith('#'):
                return 'suse系统参数不符合要求',0,'请修改/etc/systemd/system.conf中DefaultTasksMax=2048,并重启服务器生效'
            else:
                _suse = out_suse.split('=')
                try:
                    if ':' in _suse[1]:
                        num = int(_suse[1].split(':')[1])
                    else:
                        num = int(_suse[1])
                except:
                    num = 0
                if num < 2048:
                    return 'suse系统参数不符合要求',0,'请修改/etc/systemd/system.conf中DefaultTasksMax=2048,并重启服务器生效'
        if ostype == 'Kylin-V10':
            out_kylin = os.popen("cat /etc/systemd/system.conf|grep -v '#'|grep 'DefaultLimitNOFILE' ").read().strip('\n')
            if out_kylin.startswith('#'):
                return 'kylin-v10系统参数不符合要求',0,'请修改/etc/systemd/system.conf中DefaultLimitNOFILE=65535,并重启服务器生效'
            else:
                _kylin = out_kylin.split('=')
                
                try:
                    if ':' in _kylin[1]:
                        num = int(_kylin[1].split(':')[1])
                    else:
                        num = int(_kylin[1])
                except:
                    num = 0
                if num < 65535:
                    return 'kylin系统参数不符合要求',0,'请修改/etc/systemd/system.conf中DefaultLimitNOFILE=65535,并重启服务器生效'
            
        return '系统参数正常',1,''

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        return self.checkSystem()

if __name__ == '__main__':
    checkSystem = CheckSystem()
    info,status,suggest = checkSystem.main()
    print(json.dumps({'info': info,'name':'检测系统参数', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


